﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Text.RegularExpressions;
using SeizyUtils.Common.Utilities;

namespace SeizyUtils.Common.Data.Database.Parse
{
    class WhereState : IParseState
    {
        private readonly StringBuilder iWhereClause;

        public WhereState()
        {
            iWhereClause = new StringBuilder();
        }

        public IParseState ReadLine(string line, StringBuilder resultSql, QueryParam param)
        {
            if (line.StartsWith("[where end]"))
            {
                // Where句を追加する
                if (iWhereClause.Length > 0)
                {
                    resultSql.Append("\n where ");
                    resultSql.Append(IgnoreAndOr(iWhereClause.ToString()));
                }
                return new ReadState();
            }

            //パラメータを置換する
            iWhereClause.Append(QueryParser.replaceParam(line, param));
            iWhereClause.Append("\n");
            return this;
        }

        /// <summary>
        /// WHERE句の先頭にAND,ORが存在する場合は、除外する
        /// </summary>
        /// <param name="result"></param>
        /// <returns></returns>
        private string IgnoreAndOr(string result)
        {
            if (iWhereClause.Length == 0)
            {
                result = result.Trim().ToLower();
                if (result.StartsWith("and"))
                {
                    result = result.Substring(3);
                }
                else if (result.StartsWith("or"))
                {
                    result = result.Substring(2);
                }
            }
            return result;
        }

    }
}
