﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SeizyUtils.Common.Data.Database
{
    /// <summary>
    /// IQueryを実行する際のパラメータを保持するクラスです。
    /// </summary>
    class QueryParam
    {
        private readonly Dictionary<string, object> _params = new Dictionary<string, object>();

        /// <summary>
        /// パラメータをセットします。
        /// </summary>
        /// <param name="columnName"></param>
        /// <param name="value"></param>
        public void set(string columnName, object value)
        {
            _params[columnName] = value;
        }
        
        /// <summary>
        /// パラメータを取得します。
        /// </summary>
        /// <param name="columnName"></param>
        /// <returns></returns>
        public object get(string columnName)
        {
            return _params[columnName];
        }

        /// <summary>
        /// パラメータが含まれているかチェックします。
        /// </summary>
        /// <param name="columnName"></param>
        /// <returns></returns>
        public bool contains(string columnName)
        {
            return _params.ContainsKey(columnName);
        }

    }
}
