﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SeizyUtils.Common.Data;

namespace SeizyUtils
{
    class Definition : IDefinition
    {
        private readonly string _defName;

        private readonly IList<IColumn> _columns = new List<IColumn>(); 

        public Definition(string defName)
        {
            _defName = defName;
        }

        public IList<IColumn> GetColumns()
        {
            return _columns;
        }

        public string getDefinitionName()
        {
            return _defName;
        }

        /// <summary>
        /// カラムを登録します。
        /// このメソッドは、Internal Use Onlyです。
        /// フレームワーク利用者は呼び出さないでください。
        /// </summary>
        /// <param name="column"></param>
        public void internalAddColumn(IColumn column)
        {
            _columns.Add(column);
        }

    }
}
