﻿namespace SeizyUtils.AppCode.Common.Data
{
    /// <summary>
    /// 進捗を監視するインターフェースです。
    /// </summary>
    public interface IProgressObserver
    {
        /// <summary>
        /// 進捗が進んだときに処理を行います。
        /// </summary>
        /// <param name="count">実行済件数</param>
        /// <param name="totalCount">総件数</param>
        void Update(int count, int totalCount);

        /// <summary>
        /// 次のファイルを処理するときに処理を行います。
        /// </summary>
        void NextFile();
    }
}